#!/bin/sh
## set -xe # L'un ou l'autre. #
killall -q aemenu-pango;sleep 0.1 #

. /usr/local/share/MRUF/vars.GEN1
[ -f $MRUFrep/FirstRun ] && Get-Gtk-Theme.sh && exit

cd $MRUFrep # Habillage par défaut & Variables
[ ! -f Fonte ] && echo "OpenSans-Light" > Fonte;Caract="`head -1 $MRUFrep/Fonte`"
[ ! -f Size ] && echo 12 > Size;Size="`head -1 $MRUFrep/Size`"
[ ! -f Color ] && echo -e "bisque\nsnow" > Color
Color1="`head -1 $MRUFrep/Color`";Color2="`tail -1 $MRUFrep/Color`"

# LANG=en_CA.utf8 # Uncomment this line to force debugging / testing of the script in English.
# Re-comment this line for normal operation in your localized language.

NexistePas () {
case "${LANG:0:2}" in fr)TXTMSG4="
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"\t\t\t\t\t<span color='red'><span rise='-9000' underline='double'><i> Hum... </i></span></span>\" \" \"
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"Comme le registre des fichiers récents « recently-used.xbel » \" \" \"
cmd \"  ne contient rien encore, ou qu'il n'existe plus, ce script ne \" \" \"
cmd \"  peut rien afficher. Faites quelques opérations pour recréer  \" \" \"
cmd \"     ou repeupler le fichier « xbel » et réessayez plus tard. \" \" \"
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"\t\t\t     <span color='red'><i>~~~~~~~~~~~~~~</i></span>\" \"\"
cmd \" \" \" \"" ;;
	en|*)TXTMSG4="
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"\t\t\t\t<span color='red'><span rise='-9000' underline='double'><i> Hm... </i></span></span>\" \" \"
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"There is nothing in file recently-used.xbel right now\" \" \"
cmd \"  -- or it doesn't exist --, so this script can't display\" \" \"
cmd \"      anything yet. Please do a few operations to \" \" \"
cmd \"   recreate | repopulate the file and try again later. \" \" \"
cmd \"<span font='Sans 4'><span color='$Color2'><i> </i></span></span>\"  \" \"
cmd \"\t\t     <span color='red'><i>~~~~~~~~~~~~~~</i></span>\" \"\"
cmd \" \" \" \"" ;;
esac
echo -e "$TXTMSG4" > /tmp/NexistePas
aemenu-pango -rc /tmp/NexistePas
exit
}

####
case "$@" in
	A|a|H|h)TitrE="                 ~~~~~~ $MRUFv ~~~~~~"
	ExecS="aemenu-pango & bcm (vovchik), bash (v. >= 4.2; Fox & al.),
     less (Greenwood), replaceit (Daniels), sfs_load (shinobar), UExtract
     (SFR), urxvt (v. >= 9.2; Lehmann & al.), file (Darwin & al.)."
	DonneeS=".mtpaint, (.)recently-used.xbel, geany.conf. ## Options :
     global_history.dat, bookmarks (links2 & MZ), sqlite*, history
     (Vivaldi, Chrom* et al.)."
	BashS="hic-et-nunc2.sh, CleanMTPaintHistory.sh, gpl3.sh,
     mc.sh, sqlitemanager.sh (BarryK), visionner-avec-less4c.sh, etc."
     FiN="  https://tinyurl.com/ycmxqvem; MRUF-lst: https://tinyurl.com/y8bfgfvv\e[0m\n
   #######################################################################"
	case "${LANG%_*}" in	en)echo -e "\n\n   $TitrE\n\n      Allows access to files and directories you used most recently
     (MRUF|MRUD). Usable within Puppy|Quirky with most WM's and FM's.
        This app can be a great time-saver in your daily computing.\n
       \e[33m(c) Christian L'Écuyer, alias « musher0 » (PuppyLinux forum),
       Gatineau (Qc), Canada, end of Oct.-beg. of Nov. 2012. # Edits:
      Oct. 15, Nov. 16 2013 to end of June - Aug. 6 2017 (v. 0.9.8.2).\e[0m
   \t       \e[33mGPL3: https://opensource.org/licenses/GPL-3.0\e[0m\n
   \t\t\t   \e[32m\e[4m~~~ Required ~~~\e[24m
   Exec.: $ExecS\n   Data: $DonneeS\n   Bash Scripts: $BashS
     (I authored those scripts unless otherwise mentioned.)\n\e[0m
                \e[36m~~~  Credits, thanks and references  ~~~
      Icon: Puppus Dogfellow. ### Comments: BarryK, Lazy_Puppy, Mike
   Walsh, MochiMoppei, stu91, torm. ## Ref.: aemenu-pango & bcm (vovchik),
  $FiN
                    (Type 'Enter' to close this panel.)" ;;
     fr)echo -e "\n\n   $TitrE\n\n     Permet d'accéder aux répertoires et fichiers récemment utilisés.
    \t  S'utilise dans Puppy|Toutou|Quirky avec la plupart des
                 gestionnaires de fenêtres et de fichiers.
        Cette application peut vous faire gagner beaucoup de temps.\n
       \e[33m(c) Christian L'Écuyer, alias « musher0 » (forum PuppyLinux),
     Gatineau (Qc), Canada, fin oct. - début nov. 2012. ### Révisions :
        15 oct., 16 nov. 2013 à fin juin - 6 août 2017 (v. 0.9.8.2).
   \t       \e[33mGPL3 : https://opensource.org/licenses/GPL-3.0\e[0m\n
   \t\t\t      \e[32m\e[4m~~~ Requis ~~~\e[24m
   Exéc. : $ExecS\n   Données: $DonneeS
   Scripts en bash : $BashS
     (Je suis l'auteur de ces scripts sauf indication contraire.)\n\e[0m
             \e[36m~~~  Crédits, remerciements et références  ~~~
   Icône : Puppus Dogfellow.  ##  Obs. : BarryK, Lazy_Puppy, Mike Walsh,
    MochiMoppei, stu91, torm.  ##  Réf. : aemenu-pango & bcm (vovchik),
  $FiN
                    (Taper 'Entrer' pour fermer ce panneau.)" ;;
     esac;read ;; # Description

	*)LC_ALL=C
	[ ! -f /root/.local/share/recently-used.xbel ] && NexistePas
	[ "`grep file $XBelsrc | wc -l`" = "0" ] && NexistePas
# Vérification essentielle : si le fichier xbel existe et s'il contient des références à des fichiers.

# Si tout est beau, le script se met à l'ouvrage.
	if [ ! -f SqlitE ];then
		[ -f /usr/local/bin/sqlitemanager.sh ] && echo "/usr/local/bin/sqlitemanager.sh" > SqlitE
	fi
	[ -f SqlitE ] && SqlitE="`head -1 $MRUFrep/SqlitE`"

# For file managers # Thanks to Mike Walsh for this suggestion. # Sept. 5 2016
	[ ! -f FileMan ] && echo rox > FileMan;FM="`head -1 $MRUFrep/FileMan`"
	SpaN2="</span></span>"

# Construction du menu # En-tête
	echo -e "### aemenu ###\n# This is a dynamic file! # Ce fichier change tout le temps !
# Do not edit directly.  # # Ne pas éditer directement.\n# aemenu pour MRUF-lst.*
# ${LANG%_*} \n" > /tmp/en-tete
Temps="`date '+%R'`"
case "${LANG%_*}" in fr)DOCREC=" Documents récents";DaT="`date '+%a. %d %b. %Y'`" ;;
	en|*)DOCREC=" Recent Documents";DaT="`date '+%a. %b. %d %Y'`" ;;
esac
echo -e "cmd \"    <span color='$Color2'><span rise='9000' underline='double'><i> $DaT </i></span></span>\" \"/usr/local/bin/hic-et-nunc2.sh;$MRUF\"" >> /tmp/en-tete

LarGEcran="`xwininfo -root | awk '$1 ~ /Width/ { print $2 }'`";CutOff=1024
if [ "$LarGEcran" -gt "$CutOff" ];then # Wider / narrower screens
	echo -e "menu \" <span rise='9000' font='$Caract bold $Size'><span color='$Color1'><i>$DOCREC</i>$SpaN2\"" >> /tmp/en-tete
else
	echo -e "cmd \" <span rise='9000' font='$Caract bold $Size'><span color='$Color1'><i>$DOCREC</i>$SpaN2\" \" \" " >> /tmp/en-tete
fi

# Corps
	[ ! -f $corps -o "`grep -ow ${LANG%_*} /tmp/en-tete`" = "" ] && CndtN1="non" || CndtN1="oui"

	[ "`ls -Algo $XBelsrc | awk '{ print $3 }'`" != "`cat XbelSize`" 	-o "`ls -AlgoH /usr/local/bin/$MRUFv | awk '{ print $3 }'`" != "`cat ScriptSize`" ] && CndtN2="non" || CndtN2="oui"

	[ "`ls -Algo /root/.config/geany/geany.conf | awk '{ print $3 }'`" != "`cat /root/.config/geany/Size.geany.conf`" -o "`ls -Algo /root/.mtpaint | awk '{ print $3 }'`" != "`cat /root/Size.mtpaint`" ] && CndtN3="non" || CndtN3="oui"

	if [ "$CndtN1" = "non" -o "$CndtN2" = "non" -o "$CndtN3" = "non" ];then
	# See Size stamps towards end of script. For detection of:
	# menu existence, language, freshness, script editing, etc.

# Attente
		case "${LANG:0:2}" in fr)TXTMSG3="

Le menu doit être mis à jour.
... Merci de votre patience ...
" ;;
			en|*)TXTMSG3="

The menu must be updated.
... Thanks for waiting ...
" ;;
		esac
		bcm -u /usr/local/share/pixmaps/mrudicon2-48x-trnsprnt.png -a 1 -g c:c -d 3 -b "#000000FF" -c "#0c0c0c8F" -t "<span font='LiberationSerif Bold Italic 18' color='$Color1' gravity='north' gravity_hint='line'>$TXTMSG3</span>" 2>/dev/null &

# Variables
		. /usr/local/share/MRUF/vars.GEN2
		[ ! -L $XBel ] && ln -s /root/.local/share/recently-used.xbel $XBel

		LnG="${LANG%_*}";[ "$LnG" != "fr" -a "$LnG" != "en" ] && LnG="en"
		. /usr/local/share/MRUF/vars.$LnG
# Read file / Lire le fichier # /usr/share/doc/MRUF-lst/MRUF-langues.txt
# to implement other languages. / pour implémenter d'autres langues.

# Fonctions
		RplaciT () { replaceit --input=${j} "/initrd/mnt/dev_save" "/mnt/home"; }
##
		EnD  () {
echo "end
" >> $corps;	}
##
		tITRe () { echo -e "
menu \"$SpanSizE2<i> ${j}</i>$SpaN2\"\n\t$LignESpaN" >> $corps; }
##
		dIRs () { dir="";
for dir in `cat ${j}`;do
	if [ -d "${dir#*//}" ];then A="${dir#*//}"
		if [ "${#A}" -gt 55 ];then
			A="${A:35:${#A}}"
			echo -e "\tcmd \"...$A\" \"$FM '${dir#*//}'\"" >> $corps
		else
			echo -e "\tcmd \"${dir#*//}\" \"$FM '${dir#*//}'\"" >> $corps
		fi
	fi
done; }
##
		MRUD () { k="";k="${j}";j="";j="/tmp/MRUFprog";
RplaciT
j="";j="${k}";i=""
for i in `cat /tmp/MRUFprog`;do
	if [ -f "$i" ];then A="${i}"
		if [ "${#A}" -gt 55 ];then # Long lines. / Lignes longues.
			A="${A:35:${#A}}"
			echo -e "\tcmd \"...$A\" \"$FM '${i}'\"" >> $corps
		else
			echo -e "\tcmd \"${i}\" \"$FM '${i}'\"" >> $corps
		fi
	fi
done
echo -e "\t$LignESpaN" >> $corps
j="";j="⚫ M. R. U. Dirs";tITRe
> /tmp/MRUDprog
i=""
for i in `cat /tmp/MRUFprog | grep -v recent_files`;do
	[ -f "$i" ] && dirname $i >> /tmp/MRUDprog
done
k="";k="${j}";j="";j="/tmp/MRUDprog2"
sort -u /tmp/MRUDprog > ${j}
RplaciT;dIRs;j="${k}";EnD; }
##
		DefEdVieW () {
echo -e "\t$LignESpaN\n   \tcmd \"   default${j}editor\" \"default${j}editor;$MRUF\"
	\tcmd \"   default${j}viewer\" \"default${j}viewer;$MRUF\"" >> $corps
EnD; }
##
		Shorten () { V="${file#*//}";V="`echo ${V} | awk -F"/" '{ print "..."$(NF-2)"/"$(NF-1)"/"$NF }'`"; } # Long lines.
##
		FilHndlR () {
if [ -f "${file#*//}" ];then
	if [ "`file -b ${file#*//} | awk '/package|compression/'`" ];then
		#	if [[ "${file#*//}" =~ .*pet.* ]];then # Façon regex. # Note pour moi.
		Shorten
		echo -e "\tcmd \"${V}\" \"/usr/local/apps/UExtract/AppRun '${file#*//}';$MRUF\"" >> $corps
	elif [ "`file -b ${file#*//} | awk '/Squashfs/'`" ];then Shorten
		echo -e "\tcmd \"${V}\" \"sfs_load '${file#*//}';$MRUF\"" >> $corps
	elif [ "`file -b ${file#*//} | awk '/[Zz]ip/'`" ];then Shorten
		echo -e "\tcmd \"${V}\" \"xarchive '${file#*//}';$MRUF\"" >> $corps
	elif [ "`file -b ${file#*//} | awk '/text/'`" ];then Shorten
		echo -e "\tcmd \"${V}\" \"defaulttextviewer '${file#*//}';$MRUF\"" >> $corps
	elif [ "`file -b ${file#*//} | awk '/image/'`" ];then Shorten
		echo -e "\tcmd \"${V}\" \"defaultimageviewer '${file#*//}';$MRUF\"" >> $corps
	else
		Shorten;echo -e "\tcmd \"${V}\" \"xdg-open ${file#*//};$MRUF\"" >> $corps
	fi
fi; }
##
		BacKuP () { BkP="";BkP="cp -f --backup ${j} ${j}.bkp";
echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"
\tcmd \"$DSeaGR<i> ⚫ $EFF  </i>$SpaN2\" \"$BkP;rm -f ${j};rm -f $corps;$MRUF\"" >> $corps
EnD; }
##
		BkPLine (){
echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"
	$LignESpaN" >> $corps; }
##
		EffacE () {
			echo -e "\tcmd  \"$DSeaGR<i> ⚫ $EFF  </i>$SpaN2\" \"$BkP;Clean${j}History.sh;rm -f $corps;$MRUF\"
	$LignESpaN" >> $corps; }
##
		gMplyR () { j="";j="${k}/mplayer.lst";
> ${j}
gui=""
for gui in gui.${ending};do
	[ "`wc -l < $gui`" -gt "0" ] && cat $gui >> ${k}/mplayer.lst
	RplaciT
done
sort -u ${j} | head -n 7 > /tmp/MRUFprog; }

		ChoiX () {
echo -e "\t$LignESpaN\n	cmd \"$DSeaGR<i> ⚫ $ChoiX  </i>$SpaN2\" \" \"\n	\t$LignESpaN
" >> $corps; }

		EcourtE () {
if [ "${#http}" -gt 60 ];then
	V=$http;V="${V:8:20}";l="`echo $[${#http} - 25]`";W="${http:$l:${#http}}"
	echo -e "\tcmd \"...$V...$W\" \"$browser $http\"" >> $corps
else echo -e "\tcmd \"...${http:8:${#http}}\" \"$browser $http\"" >> $corps
fi; }  # Thanks to forum member torm for the idea.

###
#### We build! | On construit ! :-)
	> $corps
		echo -e "\t$LignESpaN" >> $corps
		j="";j="⚫ ' xbel '";tITRe
#
		j="";j="⚫ $FiL";tITRe
		if [ "`awk -F'\"' '$0 ~ /href/ && $2 !~ /'${PicS}'|\.sh|MRUF|init|etc|recents/ { print $2 }' $XBel | wc -l`" != "0" ];then
			> /tmp/dir-catalog
			file="";for file in `awk -F"\"" '/href/ && $2 !~ /'${PicS}'|\.sh|MRUF|init|etc|recents/ { print $2 }' $XBel | tail -n 14`;do
				FilHndlR
				[ "${file#*//}" = "" ] || dirname "${file#*//}" >> /tmp/dir-catalog # Prép. pour M.R.U.D., 3e ci-dessous.
			done
			echo -e "\t$LignESpaN
	\tcmd \"$SpanSizE3<i>⚫ ($FichRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		fi
		EnD # General files
#
		j="";j="⚫ Images";tITRe
		file="";for file in `awk -F"\"" '$2 ~ /'${PicS}'/ { print $2 }' $XBel | tail -n 14`;do
			FilHndlR
		done
		echo -e "\t$LignESpaN
	\tcmd \"$SpanSizE3<i>⚫ ($ImGRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # Images
#
		j="";j="⚫ $APPS";tITRe
		for app in `awk -F";" '$1 ~ /exec/ { print $2 }' $XBel | awk '{ print $1 }' | sort -u`;do
			[ "`which $app`" ] && echo "cmd $app \"$app;$MRUF\"" >> $corps
		done;echo -e "\t$LignESpaN
	\tcmd \"$SpanSizE3<i>⚫ ($ApPRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # Apps
#
		j="";j="⚫ Scripts";tITRe
		awk -F"\"" '$2 ~ /\.sh/ && $2 !~ /MRUF/ { print $2,$(NF-1) }' $XBel | awk -F"T" '{ print $1 }' | sort -u -r -k 2 | head -n 14 | awk '{ print $1 }' > /tmp/scripts.xbel
		while read line;do
			echo -e "\tcmd ${line##*/} \"defaulttexteditor $line\"" >> $corps
		done < /tmp/scripts.xbel
		echo -e "\t$LignESpaN
	\tcmd \"$SpanSizE3<i>⚫ (14 $ScrpTRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # Scripts
#
		j="";j="⚫ M. R. U. Dirs";tITRe;j="";j="/tmp/dir-catalog";RplaciT
		k="";k="${j}";j="";j="/tmp/dir-catalog.uniq"
		sort -u ${k} > ${j}
		dIRs;echo -e "\t$LignESpaN
	\tcmd \"$SpanSizE3<i>⚫ ($DiRRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # MRUD
#
		j="";j="$XBelsrc";echo -e "\t$LignESpaN" >> $corps
		BacKuP
		# EnD ## End of general section | Fin de la section générale | xbel.
###
		j="";j="⚫ URLs";tITRe # URLs
##
		NamE="global_history.dat";DiR="/root/.opera/profile";
		OprAHsT="`find /root/.opera/profile -maxdepth 1 -name global_history.dat 2>/dev/null | head -1`"
		if [ "$OprAHsT" = "" ];then
			OprAHsT="`find /mnt/sd*/opera*/pro* -maxdepth 1 -name global_history.dat 2>/dev/null | head -1`"
		fi
		if [ "$OprAHsT" != "" ];then # If we have something, we create the sub-menu.
			j="";j="⚫ Opera-12.x";tITRe;
			browser=opera;http="";
			for http in `awk '/http/ && $1 !~ /'${aVOId}'/' $OprAHsT | head -n 14`
				do	EcourtE
			done
			echo -e "\t$LignESpaN\ncmd \"$HistoriQ\" \"opera about:history\"" >> $corps
			BkPOpera="cp -f --backup $OprAHsT $OprAHsT.bkp"
			echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"$BkPOpera;$MRUF\"
	\tcmd \"$DSeaGR<i> ⚫ $EFF  </i>$SpaN2\" \"[ "`ps | awk '$4 ~ /opera/'`" = "" ] && $BkPOpera && rm -f $OprAHsT;rm -f $corps;$MRUF\"
	\t$LignESpaN" >> $corps # Erasing works only if opera is not loaded.
			echo -e "\tcmd \"opera\" \"opera;$MRUF\"" >> $corps
		EnD
		fi # End, opera-12.x section
##
		for browser in links light mozilla;do
			backup="${browser}" # On fait une sauvegarde.
			k="/root/.$browser/bookmarks.html"
			if [ -f $k ];then
				j="";j="⚫ $browser";tITRe
				[ "${browser}" = "links" ] && browser="links2 -g";http="";
				for http in `awk -F'\"' '$2 ~ /http/ && $2 !~ /'${aVOId}'/ { print $2 }' $k | tail -n 14`
					do	EcourtE
				done
				echo -e "\tcmd \"$SpanSizE3<i>⚫ (pseudo-$HistoriQ)</i>$SpaN2\" \"$MRUF\"
	$LignESpaN
	\tcmd \"  $SignetS\" \"$browser file://$k;$MRUF\"" >> $corps
				[ "${browser}" = "mozilla" ] && browser="defaultbrowser"
				echo -e "\t$LignESpaN\n\tcmd \"  $MZbr\" $browser\n\t$LignESpaN" >> $corps
				EnD
			fi
			[ "${browser}" = "${backup}" ] || browser="${backup}" # On restaure au besoin.
		done
##
		ViV="`find /m* /u* -maxdepth 4 -name vivaldi-bin 2>/dev/null | head -1`";ViV="`dirname $ViV`" #
		if [ "$ViV" != "" ];then
			j="";j="⚫ Vivaldi";tITRe
			echo -e "\tcmd \"$HistoriQ\" \"cd $ViV;./vivaldi --no-sandbox --enable-grouped-history --user-data-dir=profile vivaldi://history;MRUF\"" >> $corps
			pDH="profile/Default/History"
			[ -f $MRUFrep/SqlitE ] && echo -e "\tcmd \"$HistoriQ (local)\" \"cd $ViV;$SqlitE $ViV/$pDH;$MRUF\"
	cmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cd $ViV;cp -f --backup $pDH $pDH.bkp;$MRUF\"
	$LignESpaN
	cmd \"  $MZbr\" \"cd $ViV;$ViV/lancer.sh\"
" >> $corps
		EnD;fi # End, Vivaldi section # Rev. July 23 2017
##
		if [ "`which chromium`" != "" ];then # Based on peebee's chromium-44 sfs.
			j="";j="⚫ Chromium";tITRe
			echo -e "\tcmd \"$HistoriQ\" \"chromium chrome://history;$MRUF\"" >> $corps
			cDH="/root/.config/chromium/Default/History"
			[ -f $MRUFrep/SqlitE ] && echo -e "\tcmd \"$HistoriQ  (local)\" \"$SqlitE $cDH;$MRUF\"
	cmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cp -f --backup $cDH $cDH.bkp;$MRUF\"
	$LignESpaN
	cmd \"  $MZbr\" \"`which chromium`\"" >> $corps
		EnD;fi # Fin de la section Chromium / End of Chromium section.
##
		echo -e "\t$LignESpaN\n\tcmd \"  defaultbrowser\" \"defaultbrowser;$MRUF\"
	cmd \"  defaulthtmlviewer  \" \"defaulthtmlviewer;$MRUF\"" >> $corps
		EnD # URLs
###
	j="";j="⚫ $APPS";tITRe;k="";k="/root/.config/geany/geany.conf"
		if [ -f ${k} ];then # Skipped if no Geany.
			j="";j="⚫ Geany";tITRe
			cd "${k%/*}"
			grep t_files= "${k##/*/}" | tr ";" "\n" | grep -v MRUF | head -n 14 > /tmp/MRUFprog
			echo -e "\tcmd \"$SpanSizE3<i>⚫ (Textes récents [' geany '])</i>$SpaN2\" \" \"" >> $corps
			j="";j="text";MRUD
			echo -e "\t$LignESpaN" >> $corps
			k="";k="/root/.config/geany/geany.conf"
			echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cp -f --backup ${k} ${k}.bkp;$MRUF\"
	$LignESpaN" >> $corps;
			j="";j="Geany"
			BkP="";BkP="cp -f --backup ${k} ${k}.bkp"
			EffacE
			j="";j="text";DefEdVieW # Erasing works only if program not running.
		fi # End, Geany section
###
		if [ -f /usr/bin/gmplayer ];then
			MplayeR="gmplayer" # Tester aussi avec smplayer :
			# [ -f /usr/bin/gmplayer ] && MplayeR="gmplayer" || MplayeR="smplayer"
			j="";j="⚫ gMPlayer";tITRe
			echo -e "\tcmd \"$SpanSizE3<i>⚫ $MPlyRFils</i>$SpaN2\" \" \"" >> $corps
			k="";k="/root/.mplayer";cd ${k}
			ending="";ending="url";gMplyR # Radios et autres # Aussi gui.pl? Non.
			media="";for media in `cat /tmp/MRUFprog`;do
				echo -e "\tcmd \"${media##*/}\" \"$MplayeR $media;$MRUF\"" >> $corps
			done
			echo -e "\t${LignESpaN}" >> $corps
			j="";j="⚫ M. R. U. Dirs";tITRe
			ending="";ending="history";gMplyR  # For directories
			media="";for media in `cat /tmp/MRUFprog`;do
				echo -e "\tcmd \"${media##*/}\" \"rox $media;$MRUF\"" >> $corps
			done;EnD
			echo -e "\t$LignESpaN
	\tcmd  \"$DSeaGR<i> ⚫ $EFFs  </i>$SpaN2\" \"CleanMPlayerHistory.sh;rm -f $corps;$MRUF\"
	\tcmd  \"$DSeaGR<i> ⚫ $EDTs  </i>$SpaN2\" \"defaulttexteditor ${k}/gui.history ${k}/gui.url;$MRUF\"
	\t$LignESpaN" >> $corps
			for exec in audio media video;do
				[ -f /usr/local/bin/default${exec}player ] && echo -e "\tcmd \"  default${exec}player  \" \"default${exec}player;$MRUF\"" >> $corps
			done;EnD
		fi # End, MPlayer section
###
		k="";k="/root/.mtpaint"
		if [ -f ${k} ];then # Skipped if no mtpaint.
			j="";j="⚫ Mtpaint";tITRe
			awk '$1 ~ /^file/ && $0 !~ /MRUF/ { print $3 }' ${k} | head -n 14 > /tmp/MRUFprog # | sort -u
			echo -e "\tcmd \"$SpanSizE3<i>⚫ ($ImGRecnt [' mtpaint '])</i>$SpaN2\" \" \"" >> $corps
			j="";j="image";MRUD
			echo -e "\$LignESpaN" >> $corps
			# BkP="";BkP="cp -f --backup ${k} ${k}.bkp";
			# BkPLine
			k="";k="/root/.mtpaint"
			echo -e "\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cp -f --backup ${k} ${k}.bkp;$MRUF\"
	$LignESpaN" >> $corps;
			j="";j="MTPaint"
			BkP="";BkP="cp -f --backup ${k} ${k}.bkp"
			EffacE # Erasing works only if program not running.
			j="";j="image";DefEdVieW
		fi # End, MtPaint section
###
		j="";j="⚫ SQLiteManager";tITRe
		echo -e "\tcmd \" SQLiteManager\" sqlitemanager.sh;$MRUF
	$LignESpaN
end"  >> $corps
		echo -e "\t$LignESpaN" >> $corps
		EnD
###
		j="";j="⚫ bash+Syst.";tITRe
###
		k="";for k in bash-bash_history less-lesshst noX_console-history;do
			j="";j="⚫ ${k%-*}";tITRe;j="";j=".${k#*-}"
			[ -f /root/"${j}" ] && echo -e "\tcmd \"    $HIST\" \"/opt/local/bin/visionner-avec-less.sh /root/${j};$MRUF\"" >> $corps
			BacKuP
			echo -e "\t$LignESpaN" >> $corps
		done
#
		j="";j="⚫ ' xerrs.log '";tITRe
		echo -e "\tcmd \"    xerrs.log\" \"/opt/local/bin/visionner-xerrs_log-2c.sh;$MRUF\"" >> $corps
		j="";j="/tmp/xerrs.log";BacKuP
#
		j="";j="⚫ ' Xorg.log '";tITRe;j="";j="/var/log/Xorg.0.log"
		echo -e "\tcmd \"    Xorg.log\" \"/opt/local/bin/visionner-avec-less.sh ${j};$MRUF\"
	\tcmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cp -f --backup ${j} ${j}.bkp;$MRUF\"
	\t$LignESpaN" >> $corps
#
	echo -e "\tend\n$LignESpaN\ncmd \"   console\" \"console-hdr.sh;$MRUF\"
	\tcmd \"   less\" \"cd /usr/local/bin;/opt/local/bin/visionner-avec-less.sh NQuelTxt;$MRUF\"
	\tcmd \"   $InviT\" \"killall X\"" >> $corps
	EnD # Terminal
###
		j="";case "${LANG:0:2}" in fr)j="⚫ 14 derniers" ;;
			en|*)j="⚫ Last 14" ;;
		esac;tITRe
		j="";case "${LANG:0:2}" in fr)j="⚫ paquets" ;;
			en|*)j="⚫ packages" ;;
		esac;tITRe
		cd /root/.packages
		ls -Algot *.files | head -n 14 | awk -F. '{ print $1 }' | awk '{ print $4,$5,$7 }' > /tmp/liste-PPM
		while read line;do
			echo -e "\tcmd \"${line% *}--${line##* }\" \"/opt/local/bin/visionner-avec-less.sh /root/.packages/${line##* }.*.files\"" >> $corps
		done < /tmp/liste-PPM
		echo -e "\t$LignESpaN\n	\t	cmd \"$PpM\" ppm\n	\t$LignESpaN" >> $corps
		EnD # End, 14 last packages installed by petget
#
		j="";case "${LANG:0:2}" in fr)j="⚫ Mes docs" ;;
			en|*)j="⚫ My Docs" ;;
		esac;tITRe
		cd /root/my-documents
		ls -Algot | grep -v -E "lrw|drw" | head -n 15 | awk '{ print $4,$5,$7 }' > /tmp/liste-Mes-docs
		while read line;do
			if [ "$line" != "" ];then
				echo -e "\tcmd \"${line% *}--${line##* }\" \"rox /root/my-documents/${line##* }\"" >> $corps
			fi
		done < /tmp/liste-Mes-docs
		echo -e "\t$LignESpaN" >> $corps
		EnD # End, 14 last personal docs.

		echo -e "\t$LignESpaN" >> $corps
		EnD # End, "14 Last" section

		echo -e "\t$LignESpaN" >> $corps
		[ "$LarGEcran" -gt "$CutOff" ] && EnD # For users of narrower monitors /
		# Pour les utilisateurs de moniteurs plus étroits.
#
###
		echo -e "\t$SeaGreeN" >> $corps
		j="";j="                $HlP";tITRe
		echo -e "\tcmd \"$SpanSizE2<i>   MRUF-lst (Description $CRDTS)</i>$SpaN2\" \"urxvt -$FnT -title 'MRUF-lst - Description & Credits' -bg '#49301A' -$ClR -g 80x32 -b 20 +uc -bc +sb -e MRUF-lst h;$MRUF\"\n$LignESpaN" >> $corps
#
		for ligne in "$LigN1" "$LigN2" "$LigN3";do
			echo -e "\tcmd \"$SpanBolD<i>$ligne</i>$SpaN2\" \" \"" >> $corps
		done
		echo -e "\t$LignESpaN\n	cmd \"$SpanBolD<i>$LigN7</i>$SpaN2\" \" \"
	\t$LignESpaN\n\t	cmd \"$SpanBolD<i>$LigN6</i>$SpaN2\" \" \"" >> $corps
		[ "`which chromium`" ] && echo -e "\t$LignESpaN\n\t	cmd \"$SpanBolD<i>$MayNoTLanD</i>$SpaN2\" \" \"" >> $corps
		echo -e "\t$LignESpaN" >> $corps;ligne=""
		for ligne in "$LigN8" "$LigN9" "$LigN10" "$LigN11" "$LigN12";do
			echo -e "\tcmd \"$SpanBolD<i>$ligne</i>$SpaN2\" \" \"" >> $corps
		done
		echo -e "\t$LignESpaN" >> $corps;ligne=""
		for ligne in "$LigN13" "$LigN14" "$LigN15";do
			echo -e "\tcmd \"$SpanBolD<i>$ligne</i>$SpaN2\" \" \"" >> $corps
		done
		echo -e "\t$LignESpaN\n	cmd \"$SpanBolD<i>$LigN16</i>$SpaN2\" \" \"
		\t$LignESpaN\n	cmd \"$SpanBolD<i>$LigN17</i>$SpaN2\" \" \"
		" >> $corps
		echo -e "\t$LignESpaN" >> $corps;ligne=""
		for ligne in "$LigN18" "$LigN19";do
			echo -e "\tcmd \"$SpanBolD<i>$ligne</i>$SpaN2\" \" \"" >> $corps
		done
		echo -e "\t$LignESpaN\n	cmd \"$SpanSizE2<i>   $LiC</i>$SpaN2\" /usr/share/doc/MRUF-lst/gpl3.sh
		\t$LignESpaN" >> $corps
		EnD # of Help section. / Fin de la section d'aide.
##
		j="";j="              Param.";tITRe;j="";j="   $HabiT";tITRe;j="";j="  $ClRs";tITRe
		cd $MRUFrep
		for i in `ls -1 ColorS*`;do
			ColorA="`head -1 $i`";ColorB="`tail -1 $i`"
			echo -e "\tcmd \"<span fgcolor='$ColorA'><i>  $SchM</i><span fgcolor='$ColorB'><i> $i </i>$SpaN2\" \"cat ${i} > Color;rm -f $corps;$MRUF\"" >> $corps
		done
		ChoiX;EnD # Colors
#
		j="";j="  $Taille";tITRe
		for i in 8 9 10 11 12 13 14 15 16 17;do
			echo -e "\tcmd \"      $i\" \"echo $i > $MRUFrep/Size;rm -f $corps;$MRUF\"" >> $corps
		done
		ChoiX;EnD # Sizes
#
		echo -e "\t$LignESpaN\n   cmd \"  GTK chtheme\" \"gtk_chtheme_wrapper;Get-Gtk-Theme.sh;exit\"
   \tcmd \"  $FixColors\" \"Get-Gtk-Theme.sh;exit\"" >> $corps # $MRUF ?
		EnD # Dress-up
###
		j="";j="   $FileMan";tITRe
		for flmngr in MidnightCommander_mc.sh PcMan_pcmanfm ROX-Filer_rox Xfe_xfe;do
# Add any FM that you are using in your Puppy by following above pattern.
			[ "`which ${flmngr#*_}`" ] && echo -e "\tcmd \"   ${flmngr%_*}\" \"echo ${flmngr#*_} > $MRUFrep/FileMan;$MRUF\"" >> $corps # < which > to prevent accidents.
		done
		ChoiX
		EnD # FileManagers

		echo -e "\t$LignESpaN" >> $corps
		EnD # params.
##
		echo -e "\tcmd \"       <span color='$Color2'>━━━━━━━━</span>\" \"$MRUF\"
	menu \"\t <span rise='9000' font='$Caract bold $Size'><span color='$Color1'><i>$MenU</i>$SpaN2\"
	\t$LignESpaN
	\tcmd \"$DSeaGR<i> ⚫  $RefresH </i>$SpaN2\" \"mv -f $corps $corps.bkp\"
	\tcmd \" <-~ $EDT\" \"defaulttexteditor /tmp/recents\"
	\tcmd \"$DSeaGR<i> ⚫  $RebuilD     </i>$SpaN2\" \"rm -f $corps;rm /tmp/en-tete\"
	\t$LignESpaN
end
cmd \"      $mAj $Temps \" \" \"" >> $corps #
##
		for i in /tmp/dir-catalog* /tmp/MRUF* /tmp/MRUD*;do
			rm -f $i 2>/dev/null
		done # Nettoyage / Clean-up

		ls -Algo $XBelsrc | awk '{ print $3 }' > $MRUFrep/XbelSize # Size stamps for xbel file &
		ls -AlgoH /usr/local/bin/$MRUFv | awk '{ print $3 }' > $MRUFrep/ScriptSize # this script,
		ls -Algo /root/.config/geany/geany.conf | awk '{ print $3 }' > /root/.config/geany/Size.geany.conf # geany and mtpaint config files.
		ls -Algo /root/.mtpaint | awk '{ print $3 }' > /root/Size.mtpaint

## # Touch-ups to shorten lines.
		replaceit --input=$corps "/initrd/mnt/dev_save" "/mnt/home" # Retouches pour
		replaceit --input=$corps "/initrd/mnt/tmpfs/tmp" "/tmp" # raccourcir les lignes. /
		replaceit --input=$corps "/mnt/sda1/DpupStretch-7.0b/yaya/my-documents" "/root/my-documents"
	#	replaceit --input=$corps "/mnt/sd" "..."

## # Action
		cat /tmp/en-tete $corps > /tmp/recents
	fi
### Fin du / End of / menu ###

	LC_ALL="" # Brings LC_ALL back to default value.
# Le menu prend maintenant de 2,71 à 3,24 secondes à se créer. /
# The menu now takes 2.71 to 3,24 seconds to create.

	aemenu-pango -rc /tmp/recents &>/dev/null ;; # Affichage / We show the menu.
esac # set +xe
